-----------------------------------------------------------------------------------------------
-- Client Lua Script for BobTheBuilder
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
--require "Housing"

 
-----------------------------------------------------------------------------------------------
-- BobTheBuilder Module Definition
-----------------------------------------------------------------------------------------------
local BobTheBuilder = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function BobTheBuilder:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function BobTheBuilder:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- BobTheBuilder OnLoad
-----------------------------------------------------------------------------------------------
function BobTheBuilder:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("BobTheBuilder.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- BobTheBuilder OnDocLoaded
-----------------------------------------------------------------------------------------------
function BobTheBuilder:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "BobTheBuilderForm", nil, self)
	Apollo.LoadSprites("BTBSprites.xml")
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
		--Find HDSM
		self.HDSM = Apollo.GetAddon("HousingDecorSetManager");
		if self.HDSM == nil then
		 Apollo.AddAddonErrorText(self,"HousingDecorSetManager not found");

		 return
		end
				Apollo.RegisterSlashCommand("bob", "OnBobTheBuilderOn", self)

		--when found :

		self.HDSM.dummy2 = function(caller)

			local Houz = Apollo.GetAddon("Housing");
			if Houz.nFreePlaceDecorHandle == nil or Houz.nFreePlaceDecorHandle == 0  then
			end
			nDecorHandle = Houz.nFreePlaceDecorHandle;
			        		 self.HDSM.BTBhasSelected = nDecorHandle;
			if nDecorHandle ~= nil and nDecorHandle ~= 0 then
				local tScreenInfo = HousingLib.GetDecorIconInfo(nDecorHandle)

    		    if tScreenInfo == nil then 
				local rangeoption = self.HDSM.wndNewSet:FindChild("IncludeByRange");
							if rangeoption ~= nil then rangeoption:Enable(false) end --todo andere optie aanvinken??
				else 
				local rangeoption = self.HDSM.wndNewSet:FindChild("IncludeByRange");
							if rangeoption ~= nil then rangeoption:Enable(true) end
				self.HDSM.BTBSelectedX = tScreenInfo.fWorldPosX
				self.HDSM.BTBSelectedZ = tScreenInfo.fWorldPosZ

				end
			else
							local rangeoption = self.HDSM.wndNewSet:FindChild("IncludeByRange");
							if rangeoption ~= nil then rangeoption:Enable(false) end   --todo andere optie aanvinken??

	
			end
			
		
		  	
		end


Apollo.RegisterTimerHandler("HousingDecorIconTimer", 			"dummy2", self.HDSM)
		
		
		
		local oldOnCreateNewSetBtn = self.HDSM.OnCreateNewSetBtn;
		self.HDSM.OnCreateNewSetBtn= function(caller,wndHandler, wndControl)
		
			local wndSettingsFrame = self.HDSM.wndNewSet:FindChild("SettingsFrame")
    		local wndNameEntry = wndSettingsFrame:FindChild("NewNameEntry")
    		local strName = wndNameEntry:GetText()
    		local nSaveOptions = wndSettingsFrame:GetRadioSel("IncludeDecorRadioGroup")
			if nSaveOptions ~= 4 then
			 oldOnCreateNewSetBtn (caller,wndHandler, wndControl)
			else
			--do our stuff here
			--print("Yay i can work!!");
			
			local maxrange = tonumber(wndSettingsFrame:FindChild("MaxRangeToFind"):GetText());
			--print (maxrange);
						
			

			
	 local nNumSavedSets = #self.HDSM.tSavedData.tDecorSets
	 self.HDSM.tSavedData.tDecorSets[nNumSavedSets+1] = {}
     self.HDSM.tSavedData.tDecorSets[nNumSavedSets+1].name = strName
	 self.HDSM.tSavedData.tDecorSets[nNumSavedSets+1].decor = {}
    
    local nItemHandle = 0
    local tDecorList = HousingLib.GetPlacedDecorList()
    if tDecorList ~= nil then
        local nDecorCount = 1
        for idx = 1, #tDecorList do
			local tDecorData = tDecorList[idx]
			
            if nItemHandle ~= 0 then
                HousingLib.FreePlaceDecorDisplacement_Cancel(nItemHandle)
            end
			nItemHandle = HousingLib.PreviewPlacedDecor(tDecorData.nDecorId, tDecorData.nDecorIdHi)
			local tDecorIconInfo = HousingLib.GetDecorIconInfo(nItemHandle)

			if tDecorIconInfo ~= nil then
				local deltax = 	self.HDSM.BTBSelectedX -tDecorIconInfo.fWorldPosX;
				local deltaz = 	self.HDSM.BTBSelectedZ -tDecorIconInfo.fWorldPosZ;
				if math.sqrt((deltax *deltax ) + (deltaz*deltaz)) < maxrange then
                    local tNewDecorEntry = {}
                    tNewDecorEntry.name = tDecorData.strName
					tNewDecorEntry.index = nDecorCount
                    tNewDecorEntry.decorIdLow = tDecorIconInfo.nDecorId
                    tNewDecorEntry.decorIdHi = tDecorIconInfo.nDecorIdHi
                    tNewDecorEntry.positionX = tDecorIconInfo.fWorldPosX
                    tNewDecorEntry.positionY = tDecorIconInfo.fWorldPosY
                    tNewDecorEntry.positionZ = tDecorIconInfo.fWorldPosZ
                    tNewDecorEntry.pitch = tDecorIconInfo.fPitch
                    tNewDecorEntry.roll = tDecorIconInfo.fRoll
                    tNewDecorEntry.yaw = tDecorIconInfo.fYaw
                    tNewDecorEntry.scale = tDecorIconInfo.fScaleCurrent
                    
                    self.HDSM.tSavedData.tDecorSets[nNumSavedSets+1].decor[nDecorCount] = tNewDecorEntry
                    nDecorCount = nDecorCount + 1
                end
			end
		end	
    end
    
    if nItemHandle ~= 0 then
        HousingLib.FreePlaceDecorDisplacement_Cancel(nItemHandle)
    end
    
    local wndList = self.HDSM.wndDecorSetListFrame:FindChild("DecorSetList")
    self.HDSM:ShowDecorSetListItems(wndList, self.HDSM.tSavedData.tDecorSets)

	self.HDSM.wndNewSet:Show(false, true)

			
			end
			
		end

		
		self.HDSM.OnUpdatePlaceAllDecor = function (caller)
			self:OnUpdatePlaceAllDecor(self.HDSM)
		end

		
		
		local oldOnOpenCreateNewSetWindow = self.HDSM.OnOpenCreateNewSetWindow;
		self.HDSM.OnOpenCreateNewSetWindow = function(caller,wndHandler, wndControl)
			local rangeoption = self.HDSM.wndNewSet:FindChild("IncludeByRange");
			if self.HDSM.BTBhasSelected ~= nil and self.HDSM.BTBhasSelected	~= 0 then
			 rangeoption:Enable(true)
			else
			 rangeoption:Enable(false)
			end
			
			oldOnOpenCreateNewSetWindow (caller,wndHandler, wndControl)
		end
		
		
		--[[local oldOnConfirmPlaceAllBtn = self.HDSM.OnConfirmPlaceAllBtn;
		self.HDSM.OnConfirmPlaceAllBtn= function (caller,wndHandler, wndControl)
		self:BuildIt();
		oldOnConfirmPlaceAllBtn(caller,wndHandler, wndControl);
		end]]--
		
		
		
		
		
		
		
		
		
		local oldIsDecorAvailableOnVendor = self.HDSM.IsDecorAvailableOnVendor;
    self.HDSM.IsDecorAvailableOnVendor = function(caller, tDecorData)
		if self.HDSM.wndMain:FindChild("AllowPurchaseCheckBox"):IsChecked() == false then
		 return false
		else
		 return oldIsDecorAvailableOnVendor(caller,tDecorData);
		end
		
    end

self.HDSM.BTBButtonPlace = function(caller, wndHandler, wndControl, eMouseButton )
--print("Pixieduster time!");

end

--[[local oldOnCloseHousingDecorSetManagerWindow = self.HDSM.OnCloseHousingDecorSetManagerWindow;
self.HDSM.OnCloseHousingDecorSetManagerWindow=function(caller)
    self.HDSM.wndDecorSetListFrame:FindChild("DecorSetList"):SetCurrentRow(0)
    self.HDSM.wndDecorListFrame:FindChild("DecorList"):SetCurrentRow(0)
    HousingLib.PreviewDecor_Cancel(self.HDSM.nCurrentItemHandle)
    
    self.HDSM.wndNewSet:Show(false, true)
    self.HDSM.wndCopySet:Show(false, true)
    self.HDSM.wndLoadSet:Show(false, true)
    self.HDSM.wndPlaceAll:Show(false, true)
		
    Apollo.StopTimer("DecorPlacementTimer")
    
	self.HDSM.wndMain:Show(false, true) -- hide the window
	--oldOnCloseHousingDecorSetManagerWindow(caller)
end
]]--



		
		
		
		
		--find and edit function
		local oldOnHousingDecorSetManagerOn = self.HDSM.OnHousingDecorSetManagerOn;
 self.HDSM.OnHousingDecorSetManagerOn= function(caller)
--add checkbox
	local wndButtonList = self.HDSM.wndMain:FindChild("HousingDecorSetForm")
    if wndButtonList ~= nil then
		local wndNew = wndButtonList:FindChild("AllowPurchaseCheckBox")
        if not wndNew then
        	wndNew = Apollo.LoadForm(self.xmlDoc, "AllowPurchaseCheckBox", wndButtonList, self.HDSM)
			wndNew:SetData("AllowPurchaseCheckBox")
        end
		--wndNew:SetText("Visit Home")
	else
		 --Print("No button found/made");
	end
	
	local CreateDecorSetForm= self.HDSM.wndNewSet;
    if CreateDecorSetForm ~= nil then
		local x1,y1,x2,y2 = CreateDecorSetForm:GetAnchorOffsets();
		CreateDecorSetForm:SetAnchorOffsets(x1,y1,x2,y1+295);
		OptionList = self.HDSM.wndNewSet:FindChild("SettingsFrame");
	
		local wndNew = OptionList:FindChild("IncludeByRange")
        if not wndNew then
        	wndNew = Apollo.LoadForm(self.xmlDoc, "IncludeByRange", OptionList, self.HDSM)
			wndNew:SetData("BTBIncludeByRange")
        end
		--wndNew:SetText("Visit Home")
	else
		 --Print("No button found/made");
	end

	
	local CreateDecorSetForm= self.HDSM.wndPlaceAll;
	   if CreateDecorSetForm ~= nil then
--			local x1,y1,x2,y2 = CreateDecorSetForm:GetAnchorOffsets();
--		CreateDecorSetForm:SetAnchorOffsets(x1,y1,x2,y2+200);
		
		
		VerifyForm = CreateDecorSetForm:FindChild("VerifyPlaceAllForm")
	
		local wndNew = VerifyForm:FindChild("BobTheBuilderButtonPlace")
        if not wndNew then
        	wndNew = Apollo.LoadForm(self.xmlDoc, "BobTheBuilderButtonPlace", VerifyForm, self.HDSM)
			wndNew:SetData("BTBButtonPlace")
        end
		--wndNew:SetText("Visit Home")
	else
		 --Print("No button found/made");
	end
	
	
		local CreateDecorSetForm= self.HDSM.wndPlaceAll;
	   if CreateDecorSetForm ~= nil then
			
		
	
		local wndNew = CreateDecorSetForm:FindChild("BonusBuildOptions")
        if not wndNew then
			local x1,y1,x2,y2 = CreateDecorSetForm:GetAnchorOffsets();
			CreateDecorSetForm:SetAnchorOffsets(x1,y1,x2,y1+813);
        	wndNew = Apollo.LoadForm(self.xmlDoc, "BonusBuildOptions", CreateDecorSetForm, self)
			wndNew:SetData("BTBBonusBuildOptions")
        end
		--wndNew:SetText("Visit Home")
	else
		 --Print("No button found/made");
	end

	
		
	oldOnHousingDecorSetManagerOn  (caller)
	 self.HDSM.wndMain:SetStyle("Escapable",false);
	end
-- end function
		




		
		
		
	end
end

-----------------------------------------------------------------------------------------------
-- BobTheBuilder Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/bob"
function BobTheBuilder:OnBobTheBuilderOn()
--	self.wndMain:Invoke() -- show the window
-- UI
--[[
local button = Apollo.LoadForm(self.HDSM.xmlDoc,"PlaceAllBtn", self.HDSM.wndMain:FindChild("HousingDecorSetForm"), self.HDSM)
button:SetData("xtraButton")
button:SetHeight(24)
button:SetWidth(60)
button:SetPoint("BOTTOM", HDSM.wndMain, "BOTTOM", 0, 10)
button:SetText("Close")
--button:SetScript("OnClick", function(self) PlaySound("igMainMenuOption") self:GetParent():Hide() end)

]]--

--





end


-----------------------------------------------------------------------------------------------
-- BobTheBuilderForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function BobTheBuilder:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function BobTheBuilder:OnCancel()
	self.wndMain:Close() -- hide the window
end

function BobTheBuilder.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and BobTheBuilder.tostring( v ) or
      tostring( v )
  end
end

function BobTheBuilder.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. BobTheBuilder.val_to_str( k ) .. "]"
  end
end

function BobTheBuilder.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, BobTheBuilder.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        BobTheBuilder.key_to_str( k ) .. "=" .. BobTheBuilder.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"

---------------------------------------------------------------------------------------------------
-- BonusBuildOptions Functions
---------------------------------------------------------------------------------------------------
end


function BobTheBuilder:BTBGeneratePreview( wndHandler, wndControl, eMouseButton )
--print("PixieDust time");
----print(table.tostring(self.HDSM.tPlaceAllDecorList));
 local thepreview = self.HDSM.wndPlaceAll:FindChild("ThePreview")

if self.HDSM.BTBPixieList == nil then 
 self.HDSM.BTBPixieList = {}
 else



local	i=0
	while self.HDSM.BTBPixieList[i+1] ~= nil do
	i=i+1
	thepreview:DestroyPixie(self.HDSM.BTBPixieList[i])
	self.HDSM.BTBPixieList[i] = nil;
	
	end
	


end

local dummy = self.HDSM.tPlaceAllDecorList;
local offx = tonumber(self.HDSM.wndPlaceAll:FindChild("offsetX"):GetText());
local offy = tonumber(self.HDSM.wndPlaceAll:FindChild("offsetY"):GetText());
local offz = tonumber(self.HDSM.wndPlaceAll:FindChild("offsetZ"):GetText());
if offx == nil or offz == nil then
--print("Got Nils, making zero's");
if offx == nil then offx=0 end;
if offz == nil then offz=0 end;
end
local i=0
while dummy  ~= nil and #dummy ~= 0 and i < #dummy do
i=i+1
        local tDecorDataSet = dummy[i]
--		--print(tDecorDataSet.tDecorData.positionX)
		
		
		
		self.HDSM.BTBPixieList[i]= thepreview:AddPixie({
  strText = "",
  strFont = "CRB_Interface10",
  bLine = false,
  strSprite = "CRB_MegamapSprites:sprMap_PlayerDot",
  cr = {a=1,r=0.37,g=0.00,b=1.00},
  loc = {
fPoints = {0.5,0.5,0.5,0.5},
--    nOffsets = {50,50,100,100}
    nOffsets = {offx + tDecorDataSet.tDecorData.positionX,offz + tDecorDataSet.tDecorData.positionZ,offx + tDecorDataSet.tDecorData.positionX+8,offz + tDecorDataSet.tDecorData.positionZ+8}
  },
  flagsText = {
    DT_CENTER = true,
    DT_VCENTER = true
  }
})
		
		
end


	
	
end

function BobTheBuilder:ChangeIncrement( wndHandler, wndControl, fNewValue, fOldValue, bOkToChange )
self.HDSM.wndPlaceAll:FindChild("IncrementDisplay"):SetText("+/-"..string.format("%.2f",fNewValue));
end

function BobTheBuilder:Z_AddButton( wndHandler, wndControl, eMouseButton )
local offsetZ = self.HDSM.wndPlaceAll:FindChild("offsetZ");

if offsetZ ~= nil then

 local oldz = tonumber(offsetZ:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetZ:SetText(string.format("%.2f",oldz+increment));
self:BTBGeneratePreview();


end
end

function BobTheBuilder:Z_Substract( wndHandler, wndControl, eMouseButton )
local offsetZ = self.HDSM.wndPlaceAll:FindChild("offsetZ");

if offsetZ ~= nil then

 local oldz = tonumber(offsetZ:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetZ:SetText(string.format("%.2f",oldz-increment));
self:BTBGeneratePreview();


end

end

function BobTheBuilder:X_AddClick( wndHandler, wndControl, eMouseButton )
local offsetX = self.HDSM.wndPlaceAll:FindChild("offsetX");

if offsetX ~= nil then

 local oldx = tonumber(offsetX:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetX:SetText(string.format("%.2f",oldx+increment));
self:BTBGeneratePreview();


end

end

function BobTheBuilder:X_Substract( wndHandler, wndControl, eMouseButton )

local offsetX = self.HDSM.wndPlaceAll:FindChild("offsetX");

if offsetX ~= nil then

 local oldx = tonumber(offsetX:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetX:SetText(string.format("%.2f",oldx-increment));
self:BTBGeneratePreview();


end


end

function BobTheBuilder:Y_AddClick( wndHandler, wndControl, eMouseButton )

local offsetY = self.HDSM.wndPlaceAll:FindChild("offsetY");

if offsetY ~= nil then

 local oldy = tonumber(offsetY:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetY:SetText(string.format("%.2f",oldy+increment));
self:BTBGeneratePreview();


end

end

function BobTheBuilder:Y_Substract( wndHandler, wndControl, eMouseButton )
local offsetY = self.HDSM.wndPlaceAll:FindChild("offsetY");

if offsetY ~= nil then

 local oldy = tonumber(offsetY:GetText())
 local increment = tonumber(self.HDSM.wndPlaceAll:FindChild("IncrementSlider"):GetValue())
offsetY:SetText(string.format("%.2f",oldy-increment));
self:BTBGeneratePreview();


end

end
function BobTheBuilder:ConvertToBuildOrder(HDSM)
local BO = {};
 if HDSM.tPlaceAllDecorList ~= nil and #HDSM.tPlaceAllDecorList ~= 0 then
	local i=0;
	while HDSM.tPlaceAllDecorList[i+1]~= nil do
		i=i+1
		BO[i]={};
		BO[i] = HDSM.tPlaceAllDecorList[i].tDecorData;
		BO[i].done = false;
		end
		
	--[[


        local tDecorDataSet = table.remove(self.tPlaceAllDecorList, 1)
        self.tCurrentDecorData = tDecorDataSet.tDecorData
        if tDecorDataSet.tCrateDecorData ~= nil then
            self.bFromCrate = true
            self.nCurrentItemHandle = HousingLib.PreviewCrateDecor(tDecorDataSet.tCrateDecorData.tDecorItems[1].nDecorId, tDecorDataSet.tCrateDecorData.tDecorItems[1].nDecorIdHi)
        elseif tDecorDataSet.tVendorDecorData ~= nil then
            self.bFromCrate = false
            self.nCurrentItemHandle = HousingLib.PreviewVendorDecor(tDecorDataSet.tVendorDecorData.nId)
        end
        if self.nCurrentItemHandle == 0 then
            --print("Decor preview failed! Skipping this decor.")
            self.tCurrentDecorData = nil
            self.nCurrentItemHandle = 0
        end
        Apollo.StartTimer("PlaceAllUpdateTimer")
        return
]]--
    end


return BO;
end



function BobTheBuilder:BuildIt()
	--The Build All Part!!
	--if self.HDSM == nil then Print("OMG A NIL!"); 
	--end
	
	local BuildOrder = BobTheBuilder:ConvertToBuildOrder(self.HDSM);
	-- Print(table.tostring(BuildOrder)); 
	self:BuildThisOrder(BuildOrder);
	-- oldOnConfirmPlaceAllBtn (caller,wndHandler, wndControl)
end

function BobTheBuilder:BuildThisOrder(BuildOrder)
	local bugged = {};
	local bugcounter=0;
	
	local aaa = HousingLib.GetDecorCrateList();
	--Print(#BuildOrder.." buildorders");
	if true == true then 
		--return;
	end ------------------------------------------------------------------------------------------
	local j=0
	while BuildOrder[j+1] ~= nil do
		j=j+1
		BuildOrder[j].done=false;
		BuildOrder[j].succes=false;
		
		local i = 0;
		while aaa[i+1] ~= nil and BuildOrder[j].done == false do
			i=i+1;
			if aaa[i].strName == BuildOrder[j].name then
				
				

				--Print(table.tostring(aaa[i]));
				-- local nItemHandle = HousingLib.PreviewPlacedDecor(aaa[i].nDecorId, aaa[i].nDecorIdHi)
				
				--HousingLib.ApplyPreviewEffectToDecor\
				
				--local Itemz=aaa[i].tDecorItems;
				local thedata = nil;
				local jjj = 1;
				if aaa[i].nCount > 1 then
					while aaa[i].tDecorItems[jjj] ~= nil and aaa[i].tDecorItems[jjj].done ~= nil do
						jjj=jjj+1;
					end
					thedata = aaa[i].tDecorItems[jjj]
				end
				if aaa[i].nCount ==1 then
					--Print("Single item");
					thedata = aaa[i].tDecorItems[1]
				end
				
				-- if j ==1 then
				if thedata == nil then
					--Print("Couldnt find a crate item");
					bugcounter=bugcounter+1;
					bugged[bugcounter] = BuildOrder[j];
				end
				
				if thedata ~= nil then
					
					local nItemHandle = HousingLib.PreviewCrateDecor(thedata.nDecorId,thedata.nDecorIdHi)
					--HousingLib.PlaceDecorFromCrate(nItemHandle);
					--HousingLib.CrateDecor(nItemHandle);
					-- end
					--HousingLib.GetDecorDetailsBySector()
					--if jjj == 5 then return end
					
					aaa[i].tDecorItems[jjj].done = true;
					local nItemHandle = HousingLib.PreviewCrateDecor(thedata.nDecorId,thedata.nDecorIdHi)
					if nItemHandle ~= 0 then 
						HousingLib.SetDecorPosition(50, 50, 50);

						
						local x =99;
						local y = 0;
						local z = 0;
						
						local a = 0;
						local b = 0;
						local c = 0;
						local s = 0;
						local escape =0;
						HousingLib.SetDecorPosition(BuildOrder[j].positionX, BuildOrder[j].positionY, BuildOrder[j].positionZ);
						HousingLib.SetDecorRotation(BuildOrder[j].pitch, BuildOrder[j].roll, BuildOrder[j].yaw);
						HousingLib.ScaleDecor(BuildOrder[j].scale);
						
						
						while (HousingLib.ValidateDecorPlacement(nItemHandle) == false or x > 0.01 or y > 0.01 or z > 0.01 or a > 0.01 or b > 0.01 or c > 0.01 or s > 0.001) and escape < 10 do
							escape=escape+1;
							if escape == 10 then
								if nItemHandle ~= 0 then 
									-- HousingLib.CrateDecor(nItemHandle)
									HousingLib.PreviewDecor_Cancel(nItemHandle);
									nItemHandle = 0;
									bugcounter=bugcounter+1;
									bugged[bugcounter] = BuildOrder[j];
									
								end
								
							else
								
								
								-- nItemHandle = HousingLib.PreviewPlacedDecor(aaa[i].tDecorItems[jjj].nDecorId,aaa[i].tDecorItems[jjj].nDecorIdHi)
								if nItemHandle ~= 0 then
									--print("Found it");
									
									
									HousingLib.ScaleDecor(BuildOrder[j].scale);
									HousingLib.SetDecorRotation(BuildOrder[j].pitch, BuildOrder[j].roll, BuildOrder[j].yaw);
									HousingLib.SetDecorPosition(BuildOrder[j].positionX, BuildOrder[j].positionY, BuildOrder[j].positionZ);
									--[[if HousingLib.ValidateDecorPlacement(nItemHandle) == true then
									HousingLib.PlaceDecorFromCrate(nItemHandle)
									HousingLib.FreePlaceDecorDisplacement_Confirm(nItemHandle);
									HousingLib.FreePlaceDecorDisplacement_Confirm(nItemHandle);
									HousingLib.PreviewDecor_Cancel(nItemHandle);
									nItemHandle = HousingLib.PreviewPlacedDecor(thedata.nDecorId,thedata.nDecorIdHi)
									
									end]]-- 
									
									
									
									--if HousingLib.ValidateDecorPlacement(nItemHandle) == false then Print("INVALID for"..i.." "..jjj.." "..j) end
									HousingLib.SetDecorPosition(BuildOrder[j].positionX, BuildOrder[j].positionY, BuildOrder[j].positionZ);
									HousingLib.SetDecorRotation(BuildOrder[j].pitch, BuildOrder[j].roll, BuildOrder[j].yaw);
									HousingLib.ScaleDecor(BuildOrder[j].scale);
									-- HousingLib.FreePlaceDecorDisplacement_Confirm(nItemHandle)
									-- HousingLib.FreePlaceDecorDisplacement_Cancel(nItemHandle);
									
									
									
									
									
									
									local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle);
									local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle);
									
									if tScreenInfo == nil then 
										--print("No data");
										
									else
										
										
										
										
										
										x = BuildOrder[j].positionX - tScreenInfo.fWorldPosX;
										y = BuildOrder[j].positionY - tScreenInfo.fWorldPosY;
										z = BuildOrder[j].positionZ - tScreenInfo.fWorldPosZ;
										
										a = BuildOrder[j].pitch - tScreenInfo.fPitch;
										b = BuildOrder[j].roll - tScreenInfo.fRoll;
										c = BuildOrder[j].yaw - tScreenInfo.fYaw;
										s = BuildOrder[j].scale - tScreenInfo.fScaleCurrent;
										HousingLib.TranslateDecor(x,y,z);
										HousingLib.RotateDecor(a,b,c);
										HousingLib.ScaleDecor(BuildOrder[j].scale);
										-- HousingLib.ScaleDecor(s);
									end
									
									local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle)
									local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle)
									if tScreenInfo == nil then 
										--print("No data");
										
									else
										
										
										
										
										
										x = BuildOrder[j].positionX-tScreenInfo.fWorldPosX;
										y = BuildOrder[j].positionY-tScreenInfo.fWorldPosY;
										z = BuildOrder[j].positionZ-tScreenInfo.fWorldPosZ;
										
										a = BuildOrder[j].pitch-tScreenInfo.fPitch;
										b = BuildOrder[j].roll-tScreenInfo.fRoll;
										c = BuildOrder[j].yaw-tScreenInfo.fYaw;
										s = BuildOrder[j].scale-tScreenInfo.fScaleCurrent;
										
										--print ("Tries "..escape.."x"..x.." y"..y.." z"..z.." a"..a.." b"..b.." c"..c.." s"..s);
									end
								end
							end
						end
						BuildOrder[j].done = true
						
						--aaa = HousingLib.GetDecorCrateList();
						--i=0;
					end
					
					local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle)
					if tScreenInfo == nil then 
						--print("No data");
						
					else
						
						
						
						
						
						x = BuildOrder[j].positionX-tScreenInfo.fWorldPosX;
						y = BuildOrder[j].positionY-tScreenInfo.fWorldPosY;
						z = BuildOrder[j].positionZ-tScreenInfo.fWorldPosZ;
						
						a = BuildOrder[j].pitch-tScreenInfo.fPitch;
						b = BuildOrder[j].roll-tScreenInfo.fRoll;
						c = BuildOrder[j].yaw-tScreenInfo.fYaw;
						s = BuildOrder[j].scale-tScreenInfo.fScaleCurrent;
						if HousingLib.ValidateDecorPlacement(nItemHandle) == true and x < 0.01 and y < 0.01 and z < 0.01 and a < 0.01 and b < 0.01 and c < 0.01 and s < 0.001 then
							HousingLib.FreePlaceDecorDisplacement_Confirm(nItemHandle);
							HousingLib.PlaceDecorFromCrate(nItemHandle)
							BuildOrder[j].succes= true;
						end
						
					end
					
					
					
				end
			end
			
		end
	end
	
	--print("Couldnt place "..table.tostring(bugged));
	--self.wndMain:FindChild("BuggedList"):SetText(table.tostring(bugged))
	
	
	
	
	
end

function BobTheBuilder:OnUpdatePlaceAllDecor(localHDSM)
    if localHDSM.tCurrentDecorData ~= nil then
		local pitch = localHDSM.tCurrentDecorData.pitch;
		local yaw = localHDSM.tCurrentDecorData.yaw;
		local roll = localHDSM.tCurrentDecorData.roll;
		if localHDSM.wndPlaceAll:FindChild("ConvertToDegrees"):IsChecked() == true  then
		pitch = math.deg(pitch);
		yaw = math.deg(yaw );		
		roll = math.deg(roll );
		end
		local offx = tonumber(localHDSM.wndPlaceAll:FindChild("offsetX"):GetText());
		local offy = tonumber(localHDSM.wndPlaceAll:FindChild("offsetY"):GetText());
		local offz = tonumber(localHDSM.wndPlaceAll:FindChild("offsetZ"):GetText());


        HousingLib.SetDecorPosition(localHDSM.tCurrentDecorData.positionX + offx, localHDSM.tCurrentDecorData.positionY + offy, localHDSM.tCurrentDecorData.positionZ + offz)
        HousingLib.SetDecorRotation(pitch, roll, yaw)
        HousingLib.ScaleDecor(localHDSM.tCurrentDecorData.scale)
        
        if localHDSM.bFromCrate == true then
            HousingLib.PlaceDecorFromCrate(localHDSM.nCurrentItemHandle)
        else    
            if localHDSM.wndPlaceAll:FindChild("AllowPuchasing"):IsChecked() == true  then HousingLib.Decorate(localHDSM.nCurrentItemHandle) end

        end
        
        local wndProgressForm = localHDSM.wndPlaceAll:FindChild("PlaceAllProgressForm")
        local wndProgressBar = wndProgressForm:FindChild("ProgressBar")
        localHDSM.nPlaceAllProgress = localHDSM.nPlaceAllProgress + 1
        wndProgressBar:SetProgress(localHDSM.nPlaceAllProgress)
    end
    
    if localHDSM.tPlaceAllDecorList ~= nil and #localHDSM.tPlaceAllDecorList ~= 0 then
        local tDecorDataSet = table.remove(localHDSM.tPlaceAllDecorList, 1)
        localHDSM.tCurrentDecorData = tDecorDataSet.tDecorData
        if tDecorDataSet.tCrateDecorData ~= nil then
            localHDSM.bFromCrate = true
            localHDSM.nCurrentItemHandle = HousingLib.PreviewCrateDecor(tDecorDataSet.tCrateDecorData.tDecorItems[1].nDecorId, tDecorDataSet.tCrateDecorData.tDecorItems[1].nDecorIdHi)
        elseif tDecorDataSet.tVendorDecorData ~= nil then
if localHDSM.wndPlaceAll:FindChild("AllowPuchasing"):IsChecked() == true  then
            localHDSM.bFromCrate = false
            localHDSM.nCurrentItemHandle = HousingLib.PreviewVendorDecor(tDecorDataSet.tVendorDecorData.nId)
end
        end
        if localHDSM.nCurrentItemHandle == 0 then
            --print("Decor preview failed! Skipping this decor.")
            localHDSM.tCurrentDecorData = nil
            localHDSM.nCurrentItemHandle = 0
        end
        Apollo.StartTimer("PlaceAllUpdateTimer")
        return
    end
    
    localHDSM.tCurrentDecorData = nil
    localHDSM.nCurrentItemHandle = 0
    
    local wndProgressForm = localHDSM.wndPlaceAll:FindChild("PlaceAllProgressForm")
    wndProgressForm:Show(false, true)
    localHDSM:OnCancelPlaceAllBtn()
end



















function BobTheBuilder:test( wndHandler, wndControl, nOldLeft, nOldTop, nOldRight, nOldBottom )
--print(nOldLeft.."  "..nOldTop.."  "..nOldRight.."  "..nOldBottom);
end

---------------------------------------------------------------------------------------------------
-- BobTheBuilderButtonPlace Functions
---------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
-- BobTheBuilder Instance
-----------------------------------------------------------------------------------------------
local BobTheBuilderInst = BobTheBuilder:new()
BobTheBuilderInst:Init()
